#include <stdio.h>
#ifndef UNIX
#	include <stdlib.h>
#	include <dos.h>
#else
#	include <stdlib.h>
#endif
#include <string.h>
#include <math.h>
#include "diagraph.h"

void box(int i, char *line,char *tex, int d, int D, double *xcur, double *ycur,
	double *xs, double *ys, double cs, double db, int ilength, char *length[],
	char *lenval[], int prefix, int boldboxflag, int *error)
{
	int   comma=0;
	double X = (*xcur), Y = (*ycur), XL, YL ;
	char  *xl,*yl,*xc,*yc,*lab,*dblen ;

	lab=(char *)malloc(sizeof(char)*MAXLINE) ;
	if(lab==NULL) exit(1) ;
	xl=(char *)malloc(sizeof(char)*LNAMEMAX) ;
	if(xl==NULL) exit(1) ;
	yl=(char *)malloc(sizeof(char)*LNAMEMAX) ;
	if(yl==NULL) exit(1) ;
	xc=(char *)malloc(sizeof(char)*(NUMDIGIT+2)) ;
	if(xc==NULL) exit(1) ;
	yc=(char *)malloc(sizeof(char)*(NUMDIGIT+2)) ;
	if(yc==NULL) exit(1) ;
	dblen=(char *)malloc(sizeof(char)*(NUMDIGIT+2)) ;
	if(dblen==NULL) exit(1) ;

	i++;
	while(*(line+i)==SPACE || *(line+i)==TAB)
		{
		i++ ;
		}
	if(*(line+i)=='(')
		{
		srlen(&i, line, xl, &comma, error, COMMA, ilength, length, lenval);
		if(*error==0)
			{
			XL=atof(xl);
			srlen(&i, line, yl, &comma, error, COMMA, ilength, length, lenval);
			if(*error==0)
				{
				YL=atof(yl);
				comment(&i, line, lab, error);
				if(*error==0)
					{
					if(D==0)
						{
						if (prefix==0)
							{
							gcvt(value(X),NUMDIGIT,xc);
							*xcur = (*xcur)+XL;
							}
						else /* minus command prefix specified */
							{
							gcvt(value(X-XL),NUMDIGIT,xc);
							*xcur = (*xcur)-XL;
							}
						gcvt(value(Y-YL/2),NUMDIGIT,yc);
						}
					else if(D==1)
						{
						gcvt(value(X-XL/2),NUMDIGIT,xc);
						if (prefix==0)
							{
							gcvt(value(Y),NUMDIGIT,yc);
							*ycur = (*ycur)+YL;
							}
						else /* minus command prefix specified */
							{
							gcvt(value(Y-YL),NUMDIGIT,yc);
							*ycur = (*ycur)-YL;
							}
						}
					else if(D==2)
						{
						if (prefix==0)
							{
							gcvt(value(X-XL),NUMDIGIT,xc);
							*xcur = (*xcur)-XL;
							}
						else /* minus command prefix specified */
							{
							gcvt(value(X),NUMDIGIT,xc);
							*xcur = (*xcur)+XL;
							}
						gcvt(value(Y-YL/2),NUMDIGIT,yc);
						}
					else if(D==3)
						{
						gcvt(value(X-XL/2),NUMDIGIT,xc);
						if (prefix==0)
							{
							gcvt(value(Y-YL),NUMDIGIT,yc);
							*ycur = (*ycur)-YL;
							}
						else
							{
							gcvt(value(Y),NUMDIGIT,yc);
							*ycur = (*ycur)+YL;
							}
						}
					*xs=(*xcur+X)/2;
					*ys=(*ycur+Y)/2;
					if(cs>=0)
						{
						if(D==0)
							{
							*ys = (*ys)+YL/2+cs ;
							}
						else if(D==1)
							{
							*xs = (*xs)-XL/2-cs ;
							}
						else if(D==2)
							{
							*ys = (*ys)-YL/2-cs ;
							}
						else if(D==3)
							{
							*xs = (*xs)+XL/2+cs ;
							}
                        }
					else
						{
						if(D==0)
							{
							*ys = (*ys)-YL/2+cs ;
							}
						else if(D==1)
							{
							*xs = (*xs)+XL/2-cs ;
							}
						else if(D==2)
							{
							*ys = (*ys)+YL/2-cs ;
							}
						else if(D==3)
							{
							*xs = (*xs)-XL/2+cs ;
							}
                        }
					gcvt(value(db),NUMDIGIT,dblen);
					dbox(d,dblen,xc,yc,xl,yl,lab,tex,boldboxflag);
					}
				}
			}
		}
	else
		{
		*error=1 ;
		}

	if( *error==0 )
		{
		if( XL<0 || YL<0 ) *error=2 ;
		}

	free(lab) ; free(xl) ; free(yl) ; free(xc) ; free(yc) ; free(dblen) ;
}



void dbox(int d, char *dblen, char *xc, char *yc, char *xl, char *yl,
	char *lab, char *tex, int boldboxflag )
{
	char *end;

	end=(char *)malloc(sizeof(char)*2);
	if(end==NULL) exit(1) ;

	*end=LF ; *(end+1)='\0' ;

	if ( ( (d==0) && (boldboxflag==1) ) || (boldboxflag==2) )
		{
		strcat(tex,"{\\thicklines\\put(");
		}
	else
		{
		strcat(tex,"\\put(");
		}
	strcat(tex,xc);
	strcat(tex,",");
	strcat(tex,yc);
	if(d==0)
		{
		strcat(tex,"){\\framebox(");
		}
	else if(d==1)
		{
		strcat(tex,"){\\dashbox{") ;
		strcat(tex,dblen) ;
		strcat(tex,"}(") ;
		}
	strcat(tex,xl);
	strcat(tex,",");
	strcat(tex,yl);
	strcat(tex,"){");
	strcat(tex,lab);
	strcat(tex,"}}");
	if ( ( (d==0) && (boldboxflag==1) ) || (boldboxflag==2) )
		{
		strcat(tex,"}");
		}
	strcat(tex,end);
	free(end);
}
