#include <stdio.h>
#ifndef UNIX
#	include <dos.h>
#	include <stdlib.h>
#else
#	include <stdlib.h>
#endif
#include <string.h>
#include "diagraph.h"

void interpret(char *line, char *spacetab, char *tex, char *label[], int *D,
	int ilab,
	int *flglabel, int *error, double *t, double *b, double *l, double *r,
	double *ra,
	double *rk, double *pp, double *pv, double *c, double *db, double *s,
	double *de, double *di, double *doo,
	double *xcur, double *ycur, double *oldxcur, double *oldycur,
	double *xs, double *ys,
	double *xlab, double *ylab, int *ilength, char *length[], char *lenval[],
	int *helpline, int boldboxflag, int samplerflag )
{
	char C;
	int i,dashline,v,m,d,flag,prefix;
	double Oldxcur, Oldycur ;
/**** int j ; ****/

	Oldxcur = *oldxcur ;
	Oldycur = *oldycur ;
	*error=0 ;
	prefix=0 ;
	strcpy(tex,"") ;

	i=0;
	while(*(line+i)==SPACE || *(line+i)==TAB)
		{
		spacetab[i] = (*(line+i)) ;
		i++ ;
		}
	spacetab[i]='\0' ;

	C = (*(line+i));

	if( C == '-' )
		{
		prefix = 1 ;
		i++;
		while( *(line+i) == SPACE || *(line+i) == TAB )
			{
			i++;
			}
		C = *(line+i) ;
		}

	if(C==LF)  /* if blank line */
		{
		if (prefix==1)
			{
			*error=1 ;
			return ;
			}
		strcat( spacetab, line+i ) ;
		strcat( spacetab, "" ) ;
		}
	else if(C=='c')
		{
		if (prefix==1)
			{
			*error=1 ;
			return ;
			}
		wcomment(i, line, tex, *c, *D, *xs, *ys, error);
		}
	else if( C == '$' )
		{
		if (prefix==1)
			{
			*error=1 ;
			return ;
			}
		setlen( i, line, ilength, length, lenval, error ) ;
		strcpy( spacetab,"" ) ;
		}
	else if(C==PERCENT)
		{
		if (prefix==1)
			{
			*error=1 ;
			return ;
			}
		*helpline = 1 ;
		texcom(i, line, tex, *xcur, *ycur, ilab, label, xlab, ylab,
				*ilength, length, lenval, spacetab, error);
		}
	else if(C==YENMARK) /* change the parameter of figure */
		{
		flag = 1 ;
		param(i, line, t, b, l, r, ra, s, rk, pp , pv, c, db, de, di, doo,
			*ilength, length, lenval, flag, prefix, error);
		strcpy( spacetab,"" ) ;
		}
	else if(C=='n') /* labeling */
		{
		if (prefix==1)
			{
			*error=1 ;
			return ;
			}
		strcpy( spacetab,"" ) ;
		}
	else if(C=='k') /* drawing a knot and saving the position */
		{
		if (prefix==1)
			{
			*error=1 ;
			return ;
			}
		knot(i, line, tex, *xcur, *ycur, xs, ys, *c, *D, *rk, error);
		}
	else if(C=='s')   /* drawing a sampler */
		{
		*oldxcur = *xcur ;
		*oldycur = *ycur ;
		*helpline = 1 ;
		sample(i, line, tex, *D, *s, xcur, ycur,xs,ys,*c, *ilength,
				length, lenval, prefix, samplerflag, error);
		}
	else if(C=='a')
		{
		if (prefix==1)
			{
			*error=1 ;
			return ;
			}
		add(i, line, tex, *D, *xcur, *ycur,xs,ys,*c, *ra, error);
		}
	else if(C=='r' || C=='u' || C=='l' || C=='d')
		{
		*oldxcur = *xcur ;
		*oldycur = *ycur ;
		v=0; /* not a vector */
		if(C=='r')      *D=0;
		else if(C=='u') *D=1;
		else if(C=='l') *D=2;
		else if(C=='d') *D=3;
		*helpline = 1 ;
		i++;
		while(*(line+i)==SPACE || *(line+i)==TAB)
			{
			i++ ;
			}
		if (*(line+i)!='!') /* !-postfix not specfied */
			{
			dashline = 0 ;
			i--; /* caution! (not to skip '(') */
			dline(dashline,
				   v,i, line, tex, *D, label, flglabel, xlab, ylab, ilab,
			       xcur, ycur,xs,ys,*c, *ra, *de, *di, *doo,
				   *ilength, length, lenval,
				   prefix, error);
			}
		else /* !-postfix specified */
			{
			dashline = 1 ;
			/* i--; not necessary */
			dline(dashline,
				   v,i, line, tex, *D, label, flglabel, xlab, ylab, ilab,
			       xcur, ycur,xs,ys,*c, *ra, *de, *di, *doo,
				   *ilength, length, lenval,
				   prefix, error);
			}
		}
	else if(C=='R' || C=='U' || C=='L' || C=='D')
		{
		*oldxcur = *xcur ;
		*oldycur = *ycur ;
		v=1; /* vector */
		if(C=='R')      *D=0;
		else if(C=='U') *D=1;
		else if(C=='L') *D=2;
		else if(C=='D') *D=3;
		*helpline = 1 ;
		i++;
		while(*(line+i)==SPACE || *(line+i)==TAB)
			{
			i++ ;
			}
		if (*(line+i)!='!') /* !-postfix not specfied */
			{
			dashline = 0 ;
			i--; /* caution! (not to skip '(') */
			dline(dashline,
				   v,i, line, tex, *D, label, flglabel, xlab, ylab, ilab,
			       xcur, ycur,xs,ys,*c, *ra, *de, *di, *doo,
				   *ilength, length, lenval,
				   prefix, error);
			}
		else /* !-postfix specified */
			{
			dashline = 1 ;
			/* i--; not necessary */
			dline(dashline,
				   v,i, line, tex, *D, label, flglabel, xlab, ylab, ilab,
			       xcur, ycur,xs,ys,*c, *ra, *de, *di, *doo,
				   *ilength, length, lenval,
				   prefix, error);
			}
		}
	else if(C=='p' || C=='m')
		{
		if(C=='p')		m=0;
		else if(C=='m')  m=1;
		if (prefix==0)
			{
			pm(m,i,line,tex,*D,*pp,*pv,*xcur,*ycur,error);
			}
		else /* minus command prefix specified */
			{
			pm(m,i,line,tex,*D,*pp,*pv,Oldxcur,Oldycur,error);
			}
		}
	else if(C=='g')
		{
		if (prefix==1)
			{
			*error=1 ;
			return ;
			}
		*oldxcur = *xcur ;
		*oldycur = *ycur ;
		go(i, line, label, ilab, xlab, ylab, xcur, ycur, xs, ys,
			*D, *c, error);
		strcpy( spacetab,"" ) ;
		}
	else if(C=='x' || C=='y')
		{
		if (prefix==1)
			{
			*error=1 ;
			return ;
			}
		*oldxcur = *xcur ;
		*oldycur = *ycur ;
		move(i, line, C, label, ilab, xlab, ylab, xcur, ycur, xs, ys,
				*ilength, length, lenval, error);
		strcpy( spacetab,"" ) ;
		}
	else if(C=='X' || C=='Y')
		{
		if (prefix==1)
			{
			*error=1 ;
			return ;
			}
		subcmove(i, line, C, label, ilab, xlab, ylab, xs, ys,
					*ilength, length, lenval, error);
		strcpy( spacetab,"" ) ;
		}
	else if(C=='B' || C=='b')
		{
		if(C=='B')
			{
			d=1;
			}
		else
			{
			if(C=='b') d=0;
			}
		*helpline = 1 ;
		*oldxcur = *xcur ;
		*oldycur = *ycur ;
		box(i, line, tex, d, *D, xcur, ycur, xs, ys, *c, *db,
			*ilength, length, lenval, prefix, boldboxflag, error);
		}
	else if(C=='t')
		{
		if (prefix==1)
			{
			*error=1 ;
			return ;
			}
		scdir(i, line, D, error);
		strcpy( spacetab,"" ) ;
		}
	else
		{
		*error=1 ;
		}
/*
	printf("%s\n",tex);
	printf("D=%d \n",*D);
	for(j=0;j<ilab;j++)
		{
		printf("label[%d]='%s', flag=%d\n" ,j,label[j],flglabel[j]);
		printf("(x,y) of label=(%f,%f)\n",xlab[j],ylab[j]);
		}
	printf("ilab=%d \n",ilab);
	printf("\\a=%f, \\k=%f, \\p=%f, \\v=%f, \\c=%f\n",
	*ra,*rk,*pp,*pv,*c);
	printf("current (x,y)=(%f,%f) \n",*xcur,*ycur);
*/
}
