#include <stdio.h>
#include <stdlib.h>
#include "diagraph.h"

void param(int i, char *line,double *t, double *b,double *l, double *r,
	double *ra, double *s, double *rk, double *pp ,double *pv, double *c,
	double *db, double *de, double *di, double *doo,
	int ilength, char *length[], char *lenval[],
	int flag, int prefix, int *error)
{
	char *len ;
	extern double DEFT, DEFB, DEFL, DEFR, DEFRA, DEFRK, DEFPP, DEFPV, DEFC,
		DEFD, DEFS, DEFE, DEFI, DEFO ;

	len = (char *)malloc( sizeof(char)*LNAMEMAX ) ;
	if( len == NULL ) exit(1) ;

	i++ ;
	while( *(line+i)==SPACE || *(line+i)==TAB )
		{
		i++;
		}
	switch(*(line+i))
		{
		case    't': /* change top margin */

			{
			subparam(i, line, len, ilength, length, lenval, error,
				prefix, t, DEFT);
			break;
			}

		case    'b': /* change bottom margin */

			{
			subparam(i, line, len, ilength, length, lenval, error,
				prefix, b, DEFB);
			break;
			}

		case    'l': /* change left margin */

			{
			subparam(i, line, len, ilength, length, lenval, error,
				prefix, l, DEFL);
			break;
			}

		case    'r': /* change right margin */

			{
			subparam(i, line, len, ilength, length, lenval, error,
				prefix, r, DEFR);
			break;
			}

		case    'a': /* change the diameter of add mark */

			{
			subparam(i, line, len, ilength, length, lenval, error,
				prefix, ra, DEFRA);
			if( (flag == 1) && (*error == 0) )
				{
				if ( *ra <= 0 ) *error=2 ;
				}
			break;
			}

		case	'k': /* change the diameter of knot */

			{
			subparam(i, line, len, ilength, length, lenval, error,
				prefix, rk, DEFRK);
			if( (flag == 1) && (*error == 0) )
				{
				if ( *rk <= 0 ) *error=2 ;
				}
			break;
			}

		case	'p': /* change the position of + mark */
			{
			subparam(i, line, len, ilength, length, lenval, error,
				prefix, pp, DEFPP);
			break;
			}

		case	'v': /* change the position of + mark */
			{
			subparam(i, line, len, ilength, length, lenval, error,
				prefix, pv, DEFPV);
			break;
			}

		case	'c': /* change the position of comment */
			{
			subparam(i, line, len, ilength, length, lenval, error,
				prefix, c, DEFC);
			break;
			}

		case	'd': /* change the length of dashed line */
			{
			subparam(i, line, len, ilength, length, lenval, error,
				prefix, db, DEFD);
			if( (flag == 1) && (*error == 0) )
				{
				if ( *db <= 0 ) *error=2 ;
				}
			break;
			}

		case	's': /* change the length of sampler */
			{
			subparam(i, line, len, ilength, length, lenval, error,
				prefix, s, DEFS);
			if( (flag == 1) && (*error == 0) )
				{
				if ( *s <= 0 ) *error=2 ;
				}
			break;
			}

		case	'e': /* change the length of extra-length for dashed line */
			{
			subparam(i, line, len, ilength, length, lenval, error,
				prefix, de, DEFE);
			if( (flag == 1) && (*error == 0) )
				{
				if ( *de <= 0 ) *error=2 ;
				}
			break;
			}

		case	'i': /* change the length of 'in-part' for dashed line */
			{
			subparam(i, line, len, ilength, length, lenval, error,
				prefix, di, DEFI);
			if( (flag == 1) && (*error == 0) )
				{
				if ( *di <= 0 ) *error=2 ;
				}
			break;
			}

		case	'o': /* change the length of 'out-part' for dashed line */
			{
			subparam(i, line, len, ilength, length, lenval, error,
				prefix, doo, DEFO);
			if( (flag == 1) && (*error == 0) )
				{
				if ( *doo <= 0 ) *error=2 ;
				}
			break;
			}

		case	'%': /* comments not to be written in .tex file */
			{
			if (prefix == 1) *error=1 ;
			break;
			}

		default:
			{
			*error=1 ;
			}
		}
	free(len);
}
