#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "diagraph.h"

void scline  (int i, char *line, int d, char *label[],
	double *xlab, double *ylab, int ilab, double *xcur, double *ycur,
	double *xmax, double *ymax, double *xmin, double *ymin,
	int ilength, char *length[], char *lenval[], int prefix, int *error)
{
	int j,comma=0;
	double L;
	char *lab,*len,C;

	lab=(char *)malloc( sizeof(char)*LNAMEMAX );
	if( lab == NULL ) exit(1) ;
	len=(char *)malloc( sizeof(char)*LNAMEMAX );
	if( len == NULL ) exit(1) ;

	i++;
	while(*(line+i)==SPACE || *(line+i)==TAB)
		{
		i++ ;
		}
	if(*(line+i)=='!') /* ignore !-postfix */
		{
		i++;
		while(*(line+i)==SPACE || *(line+i)==TAB)
			{
			i++ ;
			}
		}
	if(*(line+i)=='(')
		{
		while(*(line+i+1)==SPACE || *(line+i)==TAB)
			{
			i++ ;
			}
		C = (*(line+i+1)) ;
		if(C=='.' || C=='-' || isdigit(C) || C=='$')
			{
			srlen( &i, line, len, &comma, error, ')',
										ilength, length, lenval ) ;
			if(*error==0)
				{
				L=atof(len) ;
				if( ( (prefix==0)&&(d==0) ) || ( (prefix==1)&&(d==2) ) )
					{
					minmax(*xcur+L,*ycur,*xcur,*ycur,
					       xmax,ymax,xmin,ymin) ;
					*xcur = (*xcur)+L ;
					}
				else if( ( (prefix==0)&&(d==1) ) || ( (prefix==1)&&(d==3) ) )
					{
					minmax(*xcur,*ycur+L,*xcur,*ycur,
					       xmax,ymax,xmin,ymin) ;
					*ycur = (*ycur)+L ;
					}
				else if( ( (prefix==0)&&(d==2) ) || ( (prefix==1)&&(d==0) ) )
					{
					minmax(*xcur,*ycur,*xcur-L,*ycur,
					       xmax,ymax,xmin,ymin) ;
					*xcur = (*xcur)-L ;
					}
				else if( ( (prefix==0)&&(d==3) ) || ( (prefix==1)&&(d==1) ) )
					{
					minmax(*xcur,*ycur,*xcur,*ycur-L,
					       xmax,ymax,xmin,ymin) ;
					*ycur = (*ycur)-L ;
					}
				}
			}
		else
			{
			srlab(&i, line, lab, error) ;
			if(*error==0)
				{
				if( ilab==0 )
					{
					printf("\nUndefined label '%s'",lab) ;
					*error = 4 ;
					free(lab) ; free(len) ; return ;
					}
				j=0 ;
				while(strcmp(label[j],lab))
					{
					if(j==ilab-1)
						{
						printf("\nUndefined label '%s'",lab) ;
						*error = 4 ;
						free(lab) ; free(len) ; return ;
						}
					j++;
					}
				if(d==0 || d==2)
					{
					*xcur=xlab[j] ;
					}
				else if(d==1 || d==3)
					{
					*ycur=ylab[j] ;
					}
				}
			}
		}
	else
		{
		*error=1 ;
		}
	free(lab);
	free(len);
}
