#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "diagraph.h"

void setlen( int i, char *line, int *ilength, char *length[], char *lenval[],
	int *error )
{
	int j, k, period=0 ;
	char *lab, *len ;

	lab=(char *)malloc(sizeof(char)*LNAMEMAX) ;
	if( lab == NULL ) exit(1) ;
	len=(char *)malloc(sizeof(char)*LNAMEMAX) ;
	if( len == NULL ) exit(1) ;

	j=0 ;
	i++ ;
	while( *(line+i)==SPACE || *(line+i)==TAB )
		{
		i++ ;
		}
	if( isdigit( *(line+i) ) )  /* numeral */
		{
		*error=1 ;
		}
	else if( *(line+i)==PERIOD )
		{
		*error=1 ;
		}
	else if( *(line+i)=='-' )
		{
		*error=1 ;
		}
	else if( *(line+i)=='$' )
		{
		*error=1 ;
		}
	else if( *(line+i)=='=' )
		{
		*error=1 ;
		}
	else
		{
		while(1)
			{
			if(*(line+i)=='(')
				{
				*error=1 ;
				break ;
				}
			else if(*(line+i)==DBQUOTE)
				{
				*error=1 ;
				break ;
				}
			else if(*(line+i)=='=')
				{
				*error=0 ;
				break ;
				}
			else if(*(line+i)=='$')
				{
				*error=1 ;
				break ;
				}
			else if(*(line+i)==COMMA)
				{
				*error=1 ;
				break ;
				}
			else if(*(line+i)=='\0')
				{
				*error=1 ;
				break ;
				}
			else if(*(line+i)==LF)
				{
				*error=1 ;
				break ;
				}
			else if(*(line+i)==')')
				{
				*error=1 ;
				break ;
				}
			if(*(line+i)!=SPACE && *(line+i)!=TAB)
				{
				if (j == (LNAMEMAX-2) ) /* no space for NULL/'-' */
					{
					*error=9;
					free(lab);
					free(len);
					return;
					}
				*(lab+j) = (*(line+i));
				j++;
				}
			(i)++;
			}
		if(j==0)
			{
			*error=1 ;
			}
		*(lab+j)='\0' ;
		if(*error==0)
			{
			i++ ;
			while( *(line+i)==SPACE || *(line+i)==TAB )
				{
				i++ ;
				}
			j=0;
			if( isdigit( *(line+i) ) ) /* numeral */
				{
				if (j == (LNAMEMAX-2) ) /* no space for NULL/'-' */
					{
					*error=10;
					free(lab);
					free(len);
					return;
					}
				*(len+j) = (*(line+i));
				i++;
				j++;
				}
			else if(*(line+i)==PERIOD && period==0)
				{
				if (j == (LNAMEMAX-2) ) /* no space for NULL/'-' */
					{
					*error=10;
					free(lab);
					free(len);
					return;
					}
				*(len+j) = (*(line+i));
				i++;
				j++;
				period=1;
				}
			else if(*(line+i)=='-')
				{
				if (j == (LNAMEMAX-2) ) /* no space for NULL/'-' */
					{
					*error=10;
					free(lab);
					free(len);
					return;
					}
				*(len+j) = (*(line+i));
				i++;
				j++;
				}
			else
				{
				*error=1;
				}
			if(*error==0)
				{
				while(*(line+i)!=LF && *(line+i)!=PERCENT)
					{
					if(*(line+i)==SPACE || *(line+i)==TAB)
						{
						i++ ;
						}
					else if( isdigit( *(line+i) ) ) /* numeral */
						{
						if (j == (LNAMEMAX-2) ) /* no space for NULL/'-' */
							{
							*error=10;
							free(lab);
							free(len);
							return;
							}
						*(len+j) = (*(line+i));
						i++;
						j++;
						}
					else if(*(line+i)==PERIOD && period==0)
						{
						if (j == (LNAMEMAX-2) ) /* no space for NULL/'-' */
							{
							*error=10;
							free(lab);
							free(len);
							return;
							}
						*(len+j) = (*(line+i));
						i++;
						j++;
						period=1;
						}
					else
						{
						*error=1;
						break;
						}
					}
				if( *(line+i) == PERCENT )
					{
					if( *(line+i+1) != PERCENT ) *error=1 ;
					}
				}
			}
		if(j==0)
			{
			*error=1;
			}
		*(len+j)='\0' ;
		}
	if( *error == 0 )
		{
		if( *ilength >= MAXLABEL )
			{
			*error=8 ;
			free( lab ) ;
			free( len ) ;
			return ;
			}
		for( k=0 ; k < *ilength ; k++ )
			{
			if( strcmp(length[k],lab)==0 )
				{
				printf(
					"\nWarning:  Redeclaration of length '$%s'", lab ) ;
				strncpy(lenval[k],len,LNAMEMAX-1) ;
				*error = -1 ;
				break ;
				}
			}
		if (*error != -1 )
			{
			strncpy(length[*ilength],lab,LNAMEMAX-1) ;
			strncpy(lenval[*ilength],len,LNAMEMAX-1) ;
			(*ilength)++ ;
			}
		}
	free( lab ) ; free( len ) ;
}
