#include <stdio.h>
#ifndef UNIX
#	include <dos.h>
#	include <stdlib.h>
#else
#	include <stdlib.h>
#endif
#include <string.h>
#include "diagraph.h"

void texcom(int i, char *line, char *tex, double xcur, double ycur,
				int ilab, char *label[], double *xlab, double *ylab,
				int ilength, char *length[], char *lenval[],
				char *spacetab, int *error)
{
	char *xc,*yc,*C,*lab ;
	int j ;

	xc  = (char *)malloc(sizeof(char)*(NUMDIGIT+2));
	if(xc==NULL) exit(1) ;
	yc  = (char *)malloc(sizeof(char)*(NUMDIGIT+2));
	if(yc==NULL) exit(1) ;
	C = (char *)malloc(sizeof(char)*2);
	if(C==NULL) exit(1) ;
	lab=(char *)malloc(sizeof(char)*LNAMEMAX) ;
	if( lab == NULL ) exit(1) ;

	i++;
	while(*(line+i)==SPACE || *(line+i)==TAB)
		{
		*C = (*(line+i));
		*(C+1)='\0';
		strcat(spacetab,C);
		i++ ;
		}
	spacetab[i]='\0' ;

	if(*(line+i)!=PERCENT)
		{
		while( *(line+i)!=LF )
			{
			if(*(line+i)==DBQUOTE && *(line+i+1)=='x')
				{
				gcvt(value(xcur),NUMDIGIT,xc);
				strcat(tex,xc);
				i=i+2;
				}
			else if(*(line+i)==DBQUOTE && *(line+i+1)=='y')
				{
				gcvt(value(ycur),NUMDIGIT,yc);
				strcat(tex,yc);
				i=i+2;
				}
			else if(*(line+i)==DBQUOTE && *(line+i+1)=='&')
				{
				gcvt(value(xcur),NUMDIGIT,xc);
				strcat(tex,xc);
				strcat(tex,",");
				gcvt(value(ycur),NUMDIGIT,yc);
				strcat(tex,yc);
				i=i+2;
				}
			else if(*(line+i)==DBQUOTE && (*(line+i+1)=='*') )
				{
				i += 2 ;
				j = 0 ;
				while(*(line+i)!=DBQUOTE)
					{
					if(*(line+i)==LF) break ;
					if ( (*(line+i)!=SPACE) && (*(line+i)!=TAB) )
						{
						if (j == (LNAMEMAX-2) ) /* no space for NULL/'-' */
							{
							*error=9;
							free(xc);free(yc);free(C);free(lab);
							return;
							}
						*(lab+j) = (*(line+i)) ;
						j++ ;
						}
					i++;
					}
				if(*(line+i)==LF)
					{
					*error=1 ;
					free(xc);free(yc);free(C);free(lab);
					return ;
					}
				*(lab+j)='\0' ;
				i++ ;
				for ( j = 0 ; j < ilab ; j++ )
					{
					if( strcmp(label[j],lab) == 0 )
						{
						gcvt(value(xlab[j]),NUMDIGIT,lab) ;
						break ;
						}
					}
				if ( j >= ilab )
					{
					*error=7;
					printf( "\nUndefined label '%s'", lab ) ;
					free(xc);free(yc);free(C);free(lab);
					return ;
					}
				strcat(tex,lab);
				}
			else if(*(line+i)==DBQUOTE && (*(line+i+1)=='/') )
				{
				i += 2 ;
				j = 0 ;
				while(*(line+i)!=DBQUOTE)
					{
					if(*(line+i)==LF) break ;
					if ( (*(line+i)!=SPACE) && (*(line+i)!=TAB) )
						{
						if (j == (LNAMEMAX-2) ) /* no space for NULL/'-' */
							{
							*error=9;
							free(xc);free(yc);free(C);free(lab);
							return;
							}
						*(lab+j) = (*(line+i)) ;
						j++ ;
						}
					i++;
					}
				if(*(line+i)==LF)
					{
					*error=1 ;
					free(xc);free(yc);free(C);free(lab);
					return ;
					}
				*(lab+j)='\0' ;
				i++ ;
				for ( j = 0 ; j < ilab ; j++ )
					{
					if( strcmp(label[j],lab) == 0 )
						{
						gcvt(value(ylab[j]),NUMDIGIT,lab) ;
						break ;
						}
					}
				if ( j >= ilab )
					{
					*error=7;
					printf( "\nUndefined label '%s'", lab ) ;
					free(xc);free(yc);free(C);free(lab);
					return ;
					}
				strcat(tex,lab);
				}
			else if(*(line+i)==DBQUOTE && (*(line+i+1)=='@') )
				{
				i += 2 ;
				j = 0 ;
				while(*(line+i)!=DBQUOTE)
					{
					if(*(line+i)==LF) break ;
					if ( (*(line+i)!=SPACE) && (*(line+i)!=TAB) )
						{
						if (j == (LNAMEMAX-2) ) /* no space for NULL/'-' */
							{
							*error=9;
							free(xc);free(yc);free(C);free(lab);
							return;
							}
						*(lab+j) = (*(line+i)) ;
						j++ ;
						}
					i++;
					}
				if(*(line+i)==LF)
					{
					*error=1 ;
					free(xc);free(yc);free(C);free(lab);
					return ;
					}
				*(lab+j)='\0' ;
				i++ ;
				for ( j = 0 ; j < ilab ; j++ )
					{
					if( strcmp(label[j],lab) == 0 )
						{
						gcvt(value(xlab[j]),NUMDIGIT,lab) ;
						strcat(tex,lab);
						strcat(tex,",");
						gcvt(value(ylab[j]),NUMDIGIT,lab);
						strcat(tex,lab);
						break ;
						}
					}
				if ( j >= ilab )
					{
					*error=7;
					printf( "\nUndefined label '%s'", lab ) ;
					free(xc);free(yc);free(C);free(lab);
					return ;
					}
				}
			else if(*(line+i)==DBQUOTE && (*(line+i+1)=='$') )
				{
				i += 2 ;
				j = 0 ;
				while(*(line+i)!=DBQUOTE)
					{
					if(*(line+i)==LF) break ;
					if ( (*(line+i)!=SPACE) && (*(line+i)!=TAB) )
						{
						if (j == (LNAMEMAX-2) ) /* no space for NULL/'-' */
							{
							*error=9;
							free(xc);free(yc);free(C);free(lab);
							return;
							}
						*(lab+j) = (*(line+i)) ;
						j++ ;
						}
					i++;
					}
				if(*(line+i)==LF)
					{
					*error=1 ;
					free(xc);free(yc);free(C);free(lab);
					return ;
					}
				*(lab+j)='\0' ;
				i++ ;
				for ( j = 0 ; j < ilength ; j++ )
					{
					if( strcmp(length[j],lab) == 0 )
						{
						strncpy(lab,lenval[j],LNAMEMAX-1) ;
						break ;
						}
					}
				if ( j >= ilength )
					{
					*error=7;
					printf( "\nUndefined length '$%s'", lab ) ;
					free(xc);free(yc);free(C);free(lab);
					return ;
					}
				strcat(tex,lab);
				}
			else if(*(line+i)==DBQUOTE && (*(line+i+1)=='-') )
				{
				if ( *(line+i+2)=='$' )
					{
					i += 3 ;
					j = 0 ;
					while(*(line+i)!=DBQUOTE)
						{
						if(*(line+i)==LF) break ;
						if ( (*(line+i)!=SPACE) && (*(line+i)!=TAB) )
							{
							if (j == (LNAMEMAX-2) ) /* no space for NULL/'-' */
								{
								*error=9;
								free(xc);free(yc);free(C);free(lab);
								return;
								}
							*(lab+j) = (*(line+i)) ;
							j++ ;
							}
						i++;
						}
					if(*(line+i)==LF)
						{
						*error=1 ;
						free(xc);free(yc);free(C);free(lab);
						return ;
						}
					*(lab+j)='\0' ;
					i++ ;
					for ( j = 0 ; j < ilength ; j++ )
						{
						if( strcmp(length[j],lab) == 0 )
							{
							if (lenval[j][0]!='-')
								{
								strcpy(lab,"-");
								strcat(lab,lenval[j]);
								break;
								}
							else
								{
								strncpy(lab,lenval[j]+1,LNAMEMAX-1) ;
								break ;
								}
							}
						}
					if ( j >= ilength )
						{
						*error=7;
						printf( "\nUndefined length '$%s'", lab ) ;
						free(xc);free(yc);free(C);free(lab);
						return ;
						}
					strcat(tex,lab);
					}
				}
			else
				{
				*C = (*(line+i));
				*(C+1)='\0';
				strcat(tex,C);
				i++;
				}
			}
		strcat(tex,line+i) ;
		}
	else
		{
		strcpy(tex,line+i);
		}
	free(xc);free(yc);free(C);free(lab);
}
